summaryrefslogtreecommitdiffstats
path: root/git/bin/git-pull-branches
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-10 14:59:14 +0000
committerDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-10 14:59:14 +0000
commit67badd0db444736a407f6994c1a7d01c0de1ad76 (patch)
tree7e64a77b0110330f4c2bb28f3767d4786b24e8a0 /git/bin/git-pull-branches
parentInitial commit. (diff)
downloadopen-infrastructure-service-tools-67badd0db444736a407f6994c1a7d01c0de1ad76.tar.xz
open-infrastructure-service-tools-67badd0db444736a407f6994c1a7d01c0de1ad76.zip
Adding upstream version 20221223.upstream/20221223upstream
Signed-off-by: Daniel Baumann <daniel.baumann@progress-linux.org>
Diffstat (limited to 'git/bin/git-pull-branches')
-rwxr-xr-xgit/bin/git-pull-branches49
1 files changed, 49 insertions, 0 deletions
diff --git a/git/bin/git-pull-branches b/git/bin/git-pull-branches
new file mode 100755
index 0000000..9effa17
--- /dev/null
+++ b/git/bin/git-pull-branches
@@ -0,0 +1,49 @@
+#!/bin/sh
+
+# Open Infrastructure: service-tools
+
+# Copyright (C) 2014-2022 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# SPDX-License-Identifier: GPL-3.0+
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+set -e
+
+CURRENT_BRANCH="$(git branch --show-current)"
+REMOTE_BRANCHES="$(git branch -r | awk '{ print $1 }')"
+
+for REMOTE_BRANCH in ${REMOTE_BRANCHES}
+do
+ BRANCH="$(echo "${REMOTE_BRANCH}" | cut -d/ -f 2-)"
+
+ case "${BRANCH}" in
+ HEAD|"${CURRENT_BRANCH}")
+ continue
+ ;;
+ esac
+
+ if git branch | sed -e 's|\*||' | grep -qs " ${BRANCH}$"
+ then
+ git checkout "${BRANCH}"
+ git pull
+ else
+ git checkout -b "${BRANCH}" "${REMOTE_BRANCH}"
+ fi
+done
+
+if [ "$(git branch --show-current)" != "${CURRENT_BRANCH}" ]
+then
+ git checkout "${CURRENT_BRANCH}"
+fi